<script lang="typescript">
  import type { ProcuteImgModel } from "src/models/product.type";

  import { onMount } from "svelte";

  export let disable = false;
  export let imageFileList: ProcuteImgModel[] = [];

  let readimg: any;

  onMount(() => {});

  function readImage() {
    let fileToLoad = readimg.files[0];

    const fileReader = new FileReader();
    fileReader.onload = async function (fileLoadedEvent: any) {
      const textFromFileLoaded = fileLoadedEvent.target.result;
      const imgFileBase64 = await convertResolution(textFromFileLoaded);
      imageFileList.push({
        imageId: fileToLoad["name"],
        url: `${imgFileBase64}`,
      });
      imageFileList = imageFileList;
      console.log("imageFile", imageFileList);
    };
    fileReader.readAsDataURL(fileToLoad);
    readimg.value = "";
  }

  function convertResolution(base64: string) {
    return new Promise((resolve, reject) => {
      let canvas = document.createElement("canvas");
      let img = new Image();
      img.onload = function () {
        let iw = img.width;
        let ih = img.height;
        let scale = Math.min(500 / iw, 500 / ih);
        let iwScaled = iw * scale;
        let ihScaled = ih * scale;
        canvas.width = iwScaled;
        canvas.height = ihScaled;
        let ctx: any = canvas.getContext("2d");
        ctx.drawImage(img, 0, 0, iwScaled, ihScaled);
        resolve(canvas.toDataURL());
      };
      img.src = base64;
    });
  }

  function deleteImage(index: number) {
    imageFileList.splice(index, 1);
    imageFileList = imageFileList;
  }
</script>

<div class="flex w-full justify-center bg-grey-lighter border rounded">
  {#if imageFileList && imageFileList.length}
    <div
      class="grid sm:grid-cols-2 md:grid-cols-2 lg:grid-cols-4 xl:grid-cols-5 gap-4"
    >
      {#each imageFileList as imgFile, index}
        <div class="bg-gray-400 rounded m-2">
          <img
            alt="..."
            class="cursor-pointer h-32 w-32 rounded m-2 border border-gray-200 bg-white shadow"
            src={imgFile.url}
          />

          {#if !disable}
            <p
              on:click={() => deleteImage(index)}
              class="cursor-pointer text-center hover:bg-red-500 hover:text-white rounded-b text-red-600"
            >
              ลบ
            </p>
          {/if}
        </div>
      {/each}
    </div>
  {:else}
    <div class="h-32 w-32 flex justify-center items-center">
      <p class="text-white">** ไม่มีรูปภาพ</p>
    </div>
  {/if}
</div>

{#if !disable}
  <div class="flex justify-end w-full rounded mt-2">
    <div class="bg-green-400 text-white px-3 py-1 rounded-md">
      <label class="cursor-pointer">
        <p>เพิ่มรูปภาพ</p>
        <input
          id="add_image_product"
          class="hidden"
          on:change={readImage}
          bind:this={readimg}
          type="file"
          accept="image/*"
          name="image"
        />
      </label>
    </div>
  </div>
{/if}
